#include <complex.h>

enum {	ANT_EXC_MAG,
	ANT_EXC_PHA,
	ANT_POS_X,
	ANT_POS_Y,
	ANT_POS_Z,
	ANT_LAST,
	ANT_RECORD,
	ANT_NR_COLS
};

typedef struct {
  double complex v;	// Excitation
  double  x, y, z;	// Coordinates
} dipole_def;

void		new1_activate(void);
void		open1_activate(void);
void		save1_activate(void);
void		save_as1_activate(void);
void		quit1_activate(void);

void		cut1_activate(void);
void		copy1_activate(void);
void		paste1_activate(void);
void		delete1_activate(void);

void		about1_activate(void);

gboolean	MainWindow_delete_event(void);
void		MainWindow_realize(void);
gboolean	MainWindow_window_state_event(GdkEventWindowState *event);

void		xy_plane1_activate(void);
void		zx_plane1_activate(void);
void		yz_plane1_activate(void);
void		threed_view1_activate(void);
void		stereo_view1_activate(void);

void		scale_linear_btn_clicked(void);
void		scale_logv_btn_clicked(void);
void		scale_logp_btn_clicked(void);
void		scale_ARRL_btn_clicked(void);

void		linear_scale1_activate(void);
void		logv_scale1_activate(void);
void		logp_scale1_activate(void);
void		arrl_scale1_activate(void);

void		fullscreen1_activate(GtkMenuItem *item);

void		el_list_remove_btn_clicked(GtkButton *btn);
void		el_list_add_btn_clicked(GtkButton *btn);
void		el_list_edit_btn_clicked(GtkButton *btn);
void		el_list_move_up_btn_clicked(GtkButton *btn);
void		el_list_move_down_btn_clicked(GtkButton *btn);
void		el_list_mark_last_btn_clicked(GtkButton *btn);

void		mark_as_last1_activate(gpointer data);
void		edit_dipole1_activate(void);
void		delete_dipole1_activate(void);
void		antenna_list_add(double magn, double phase, double x, double y, double z, int is_last);
void		antenna_list_clear(void);

void            edit_dip_polar_rbtn_toggled(GtkToggleButton *button);

void		main_scale_btn_clicked(int which);

gboolean	plot_notebook_button_press_event(GdkEventButton *event);
GList		*specs_from_liststore(int all);
void		set_fullscreen_mode(gboolean state);

