#include <complex.h>

#define PLOT_WIDTH	500.
#define PLOT_HEIGHT	500.
#define PLOT_RADIUS	240.
#define PLOT_NR_ANGLES	36

#define PLOT_AXIS_FONT	"DejaVu Sans Mono"
#define PLOT_AXIS_SIZE	10.0
#define PLOT_AXIS_R	0.6
#define PLOT_AXIS_G	0.6
#define PLOT_AXIS_B	0.6

#define PLOT_GRAPH_R	0.0
#define PLOT_GRAPH_G	0.0
#define PLOT_GRAPH_B	0.0

#if 1
#define NR_AZ_STEPS     90
#define NR_EL_STEPS     45
#else
#define NR_AZ_STEPS     120
#define NR_EL_STEPS     60
#endif

#define AZ_STEP         360.0/NR_AZ_STEPS
#define AZ_STEP_RAD     to_rad(AZ_STEP)

#define EL_STEP         180.0/NR_EL_STEPS
#define EL_STEP_RAD     to_rad(EL_STEP)

typedef float real;

enum {	PLOT_XY,
	PLOT_XZ,
	PLOT_YZ,
	PLOT_3D,
	PLOT_STEREO
};

extern		GtkWidget       *threed_glarea;
extern		GtkWidget       *stereo_glarea;
extern		GtkWidget       *stereo_darea;

void		set_plot_scale(int scale);
real		to_rad(real angle);
real		to_deg(real angle);
complex		to_rect(real magn, real phase);
void            analyze_diagram(cairo_t *cr, int dir);

void		xy1_activate(void);
void		yz1_activate(void);
void		zx1_activate(void);
void		fullscreen_activate(GtkCheckMenuItem *menuitem);

gboolean	xy_darea_expose_event(GtkWidget *widget, GdkEventExpose *event);
gboolean	xz_darea_expose_event(GtkWidget *widget, GdkEventExpose *event);
gboolean	yz_darea_expose_event(GtkWidget *widget, GdkEventExpose *event);

void		threed_viewport_realize(GtkWidget *widget);
guint		threed_darea_realize(GtkWidget *widget);
gboolean	threed_darea_configure_event(GtkWidget *widget);
gboolean	threed_darea_expose_event(GtkWidget *widget, GdkEventExpose *event);
gboolean	threed_darea_motion_notify_event(GtkWidget *widget, GdkEventMotion *event);
gboolean	threed_darea_button_press_event(GtkWidget *widget, GdkEventButton *event);
gboolean	threed_darea_scroll_event(GtkWidget *widget, GdkEventScroll *event);

void		stereo_viewport_realize(GtkWidget *widget);
guint		stereo_darea_realize(GtkWidget *widget);
gboolean	stereo_darea_configure_event(GtkWidget *widget);
gboolean	stereo_darea_expose_event(GtkWidget *widget, GdkEventExpose *event);
gboolean	stereo_darea_motion_notify_event(GtkWidget *widget, GdkEventMotion *event);
gboolean	stereo_darea_button_press_event(GtkWidget *widget, GdkEventButton *event);
gboolean	stereo_darea_scroll_event(GtkWidget *widget, GdkEventScroll *event);

GtkWidget       *stereo_3D_drawingarea_create(GtkWidget *container);
