#include "utils.h"

int
ok_dialog(char *msg)
{
  GtkWidget *dlg, *lbl;

  dlg = gtk_message_dialog_new(NULL, 0, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, msg, NULL);

  return gtk_dialog_run(GTK_DIALOG(dlg));    
}

gboolean
run_filedialog(char *title, char **fn, gboolean openfile, ...)
{
  va_list parg;
  GtkWidget *fc;
  GtkFileFilter *ff;
  int result;       
  char *pname, *pfilt, *p;

  va_start(parg, openfile);
  if (openfile) {
    fc = gtk_file_chooser_dialog_new(title, NULL,
                GTK_FILE_CHOOSER_ACTION_OPEN,    
                GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
                NULL);
  } else {
    fc = gtk_file_chooser_dialog_new(title, NULL,
                GTK_FILE_CHOOSER_ACTION_SAVE,
                GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,  
                NULL);
    gtk_file_chooser_set_do_overwrite_confirmation(GTK_FILE_CHOOSER(fc), TRUE);
  }

  if (*fn) {
    gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(fc), p = g_path_get_dirname(*fn));
    g_free(p);
    gtk_file_chooser_set_current_name(GTK_FILE_CHOOSER(fc), p = g_path_get_basename(*fn));
    g_free(p);
  } else {
    gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(fc), ".");
    gtk_file_chooser_set_filename(GTK_FILE_CHOOSER(fc), "Untitled document");
  }

  while ((pname = va_arg(parg, char *)) != NULL) {
    pfilt = va_arg(parg, char *);
    ff = gtk_file_filter_new();
    gtk_file_filter_set_name(ff, pname);
    gtk_file_filter_add_pattern(ff, pfilt);
    gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(fc), ff);
  }
  va_end(parg);

  result = gtk_dialog_run(GTK_DIALOG(fc));
  if (result == GTK_RESPONSE_ACCEPT) {
    if (*fn) g_free(*fn);
    *fn = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(fc));
  }

  gtk_widget_destroy(fc);

  return (result == GTK_RESPONSE_ACCEPT);
}
